<script>
export default {
    name: "FilterForm",
    props: ['form'],
    data() {
        return {
            rules: {
                name: [
                    {min: 3, max: 255, message: 'Length should be 3 to 255', trigger: 'blur'},
                ],
                bedrooms: [
                    {type: 'number', message: 'Bedrooms must be a number'},
                ],
                bathrooms: [
                    {type: 'number', message: 'Bathrooms must be a number'},
                ],
                storeys: [
                    {type: 'number', message: 'Storeys must be a number'},
                ],
                garages: [
                    {type: 'number', message: 'Garages must be a number'},
                ],
            }
        }
    },
    methods: {
        async submitForm() {
            await this.$refs.ruleFormRef.validate((valid) => {
                if (valid) {
                    this.$emit('submit', this.form);
                }
            })
        }
    }
}
</script>

<template>
    <el-form ref="ruleFormRef"
             :model="form"
             label-position="top"
             :rules="rules">
        <div style="display: flex;">
            <el-form-item class="me-2" label="Name" prop="name">
                <el-input clearable v-model="form.name"/>
            </el-form-item>
            <el-form-item class="me-2" label="Bedrooms" prop="bedrooms">
                <el-input-number v-model="form.bedrooms" :min="1" :max="100"/>
            </el-form-item>
            <el-form-item class="me-2" label="Bathrooms" prop="bathrooms">
                <el-input-number v-model="form.bathrooms" :min="1" :max="100"/>
            </el-form-item>
            <el-form-item class="me-2" label="Storeys" prop="storeys">
                <el-input-number v-model="form.storeys" :min="1" :max="100"/>
            </el-form-item>
            <el-form-item class="me-2" label="Garages" prop="garages">
                <el-input-number v-model="form.garages" :min="1" :max="100"/>
            </el-form-item>
        </div>

        <el-form-item label="Garages" prop="garages">
            <el-slider v-model="form.price" range :max="1000000"/>
        </el-form-item>
        <div style="display: flex; justify-content: center">
            <el-form-item>
                <el-button type="primary" @click="submitForm">
                    Search
                </el-button>
            </el-form-item>
        </div>

    </el-form>
</template>
